package uoc.tfc.wimm;

import java.util.Calendar;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

public class ConfigGasto extends Activity implements OnClickListener{

	private View checkBox = null;
	public boolean checkMarcada = false;
	private View layout = null;
	private EditText campoCantidad = null;
	private Spinner spinnerCategoria=null;
	private TextView campoFecha = null;
	public double cantidad = 0;
	private String concepto = null;
	private int ano=0;
	private int mes=0;
	private int dia=0;
	static final int DATE_DIALOG_ID = 0;
	String fechaHoy=null;
	public static double[] cantidadesIngresoFijo = new double[10];
	public static String[] conceptosIngresoFijo = new String[10];
	public static int[] fechasIDIngresoFijo = new int[10];
	public static int[] diasIngresos = new int[10];
	static int i = 0;
	public static boolean existenGastosFijos = false;
	
	
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.configurargasto);
	
        checkBox = findViewById(R.id.checkConfGas);
        checkBox.setOnClickListener(this);
        
        layout = findViewById(R.id.layoutIntrodGas);
        
        campoCantidad = (EditText) findViewById(R.id.campoCantidadConfGas);
        
        spinnerCategoria = (Spinner) findViewById(R.id.spinnerCategoriaConfGas);
        ArrayAdapter adapter = ArrayAdapter.createFromResource(this, R.array.categoriaGasto, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinnerCategoria.setAdapter(adapter);
        
        campoFecha = (TextView) findViewById(R.id.textViewFechaConfGas);
        
        View btnCalendar = findViewById(R.id.calendarConfGas);
        btnCalendar.setOnClickListener(this);
        
        View btn_aceptar = findViewById(R.id.aceptarConfGas);
        btn_aceptar.setOnClickListener(this);
        
        View btn_atras = findViewById(R.id.cancelarConfGas);
        btn_atras.setOnClickListener(this);
        
        inicializaFecha();
	
	}
	
	public void onClick(View v) {
		switch(v.getId()){
		case R.id.checkConfGas:
			if(!checkMarcada){
				layout.setVisibility(0);
				checkMarcada = true;
			}else{
				layout.setVisibility(4);
				checkMarcada = false;
			}
			break;
		case R.id.aceptarConfGas:
			if(introducirIngresoFijo() != 0){
				openDialogOK();
			}else{
				openDialogNoOk();
			}
			startActivity(new Intent(this,WimmActivity.class));
			finish();
			break;
		case R.id.cancelarConfGas:
			Historial h = new Historial();
			h.setEsHistoric(false);
			startActivity(new Intent(this,WimmActivity.class));
			finish();
			break;
			
		case R.id.calendarConfGas:
			showDialog(DATE_DIALOG_ID);
			
			break;
		}
		
	}

	private int introducirIngresoFijo() {
		int rc = 0;
		if(checkMarcada){
			
			if(campoCantidad.getText().toString().equals(null) || campoCantidad.getText().toString().equals("")){
				cantidadNoOk();
				return rc;
			}
			
			cantidad = Double.parseDouble(campoCantidad.getText().toString());
			//Recuperar el texto del spinner
			concepto = spinnerCategoria.getSelectedItem().toString();
			String fechaSeleccion = mes+""+ano;
			int fechaID = Integer.parseInt(fechaSeleccion); 
			
			if(insertarIngresoFijo(cantidad,concepto,fechaID)){
				
				campoCantidad.setText("");
				rc = 1;
			}else{
				return rc;
			}
			
		}else{
			
		}
		return rc;
	}
	
	private boolean insertarIngresoFijo(double _cantidad, String _concepto,int _fechaID) {
		
		cantidadesIngresoFijo[i] = _cantidad;
		conceptosIngresoFijo[i] = _concepto;
		fechasIDIngresoFijo[i] = _fechaID;
		diasIngresos[i] = dia;
		existenGastosFijos = true;
		i++;
		return true;
	}

	private void cantidadNoOk() {
		new AlertDialog.Builder(this).setTitle(R.string.lbl_atencion).setItems(R.array.introducirCantidad, new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialoginterface,int which)
			{
				dialoginterface.cancel();
			}
		})
		.show();
		
	}
	
	private void openDialogNoOk() {
		new AlertDialog.Builder(this).setTitle(R.string.lbl_InsercionDatos).setItems(R.array.insercionNoOK, new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialoginterface,int which)
			{
				dialoginterface.cancel();
			}
		})
		.show();
		
	}


	private void openDialogOK() {
		new AlertDialog.Builder(this).setTitle(R.string.lbl_InsercionDatos).setItems(R.array.insercionOK, new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialoginterface,int which)
			{
				dialoginterface.cancel();
			}
		})
		.show();
	}
	
	protected Dialog onCreateDialog(int id) {
	    switch (id) {
	    case DATE_DIALOG_ID:
	        return new DatePickerDialog(this,mDateSetListener,ano, mes-1, dia);
	    }
	    return null;
	}
	
	 private DatePickerDialog.OnDateSetListener mDateSetListener = new DatePickerDialog.OnDateSetListener() {
	                
		 public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
	                    ano = year;
	                    mes = monthOfYear + 1;
	                    dia = dayOfMonth;
	                    fechaHoy = dia +" / "+mes+" / "+ano;
	                    campoFecha.setText(fechaHoy);
	                }
	 };
	 
	 public String[] getconceptosGastosFijo(){
		 return conceptosIngresoFijo;
	 }
	 
	 
	 
	 public double[] getcantidadesGastosFijo(){
		 return cantidadesIngresoFijo;
	 }
	 
	 public int[] getfechaIDGastosFijo(){
		 return fechasIDIngresoFijo;
	 }
	 
	 public boolean getExistenGastosFijos(){
		 return existenGastosFijos;
	 }
	 
	 public int[] getDiasGastos(){
		 return diasIngresos;
	 }
	 
	 private void inicializaFecha() {
			
			Calendar c = Calendar.getInstance();
	        ano = c.get(Calendar.YEAR);
	        mes = c.get(Calendar.MONTH) + 1;
	        dia = c.get(Calendar.DAY_OF_MONTH);
	        fechaHoy = dia +" / "+mes+" / "+ano;
	        campoFecha.setText(fechaHoy);
			
	 }
	 
	 public void setconceptosGastoFijo(String[] c){
		 conceptosIngresoFijo = c;
	 }
	 
	 
	 
	 public void setcantidadesGastoFijo(double[] cant){
		 cantidadesIngresoFijo = cant;
	 }
	 
	 public void setfechaIDGastoFijo(int[] f){
		 fechasIDIngresoFijo = f;
	 }
	 
	 public void setExistenGastoFijos(boolean b){
		 existenGastosFijos = b;
	 }
	 
	 public void setDiasGasto(int[] d){
		 diasIngresos = d;
	 }

	
}
