package uoc.tfc.wimm;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;

public class Eliminar extends Activity implements OnClickListener{
	boolean esMarcadoIngreso = false;
	boolean esMarcadoGasto = false;
	ConfigIngreso cf = new ConfigIngreso();
	ConfigGasto cg = new ConfigGasto();
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.eliminar);
        
        View btn_aceptar = findViewById(R.id.eliminAceptar);
        btn_aceptar.setOnClickListener(this);
        
        View btn_cancelar = findViewById(R.id.eliminCancelar);
        btn_cancelar.setOnClickListener(this);
        
        View checkIngres = findViewById(R.id.checkEliminIng);
        checkIngres.setOnClickListener(this);
        
        View checkGasto = findViewById(R.id.checkeliminGas);
        checkGasto.setOnClickListener(this);
	}
	
	public void onClick(View v) {
		switch (v.getId()){
		case R.id.eliminAceptar:
			borrarDatosFijos();
			break;
		case R.id.eliminCancelar:
//			startActivity(new Intent(this,Opciones.class));
			finish();
			break;
		case R.id.checkEliminIng:
			if(!esMarcadoIngreso){
				esMarcadoIngreso = true;
			}else{
				esMarcadoIngreso = false;
			}
			break;
		case R.id.checkeliminGas:
			if(!esMarcadoGasto){
				esMarcadoGasto = true;
			}else{
				esMarcadoGasto = false;
			}
			break;
		}
		
	}

	private void borrarDatosFijos() {
		
		boolean ingresoOk=false;
		boolean gastoOk = false;
		if(esMarcadoIngreso && cf.getExistenIngresosFijos()){
			if(resetIngresos()){
				ingresoOk = true;
			}
		}
		
		if(esMarcadoGasto && cg.getExistenGastosFijos()){
			if(resetGastos()){
				gastoOk = true;
			}
		}
		
		if(esMarcadoIngreso && ingresoOk){
			openDialogOK();
		}else if(esMarcadoIngreso && !ingresoOk){
			openDialogNoOK();
		}
		
		if(esMarcadoGasto && gastoOk){
			openDialogOK();
		}else if(esMarcadoGasto && !gastoOk){
			openDialogNoOK();
		}
		
	}

	private boolean resetIngresos(){
		try{
			String[] conceptos = cf.getconceptosIngresoFijo();
			double[] cantidades = cf.getcantidadesIngresoFijo();
			int[] fechas = cf.getfechaIDIngresoFijo();
			int[] dias = cf.getDiasIngresos();
			cf.setExistenIngresosFijos(false);
			cf.setconceptosIngresoFijo(resetConceptos(conceptos));
			cf.setcantidadesIngresoFijo(resetCantidades(cantidades));
			cf.setfechaIDIngresoFijo(resetFechas(fechas));
			cf.setDiasIngresos(resetDias(dias));
			return true;
		}catch(Exception e){
			return false;
		}
	}
	
	private boolean resetGastos(){
		try{
			String[] conceptos = cg.getconceptosGastosFijo();
			double[] cantidades = cg.getcantidadesGastosFijo();
			int[] fechas = cg.getfechaIDGastosFijo();
			int[] dias = cg.getDiasGastos();
			cg.setExistenGastoFijos(false);
			cg.setconceptosGastoFijo(resetConceptos(conceptos));
			cg.setcantidadesGastoFijo(resetCantidades(cantidades));
			cg.setfechaIDGastoFijo(resetFechas(fechas));
			cg.setDiasGasto(resetDias(dias));
			return true;
		}catch(Exception e){
			return false;
		}
	}
	
	private int[] resetDias(int[] dias) {
		int[] d = dias;
		int i = 0;
		while(i<d.length){
			d[i] = 0;
			i++;
		}
		return d;
	}

	private int[] resetFechas(int[] fechas) {
		int[]f = fechas;
		int i = 0;
		while(i<f.length){
			f[i] = 0;
			i++;
		}
		return f;
	}

	private double[] resetCantidades(double[] cantidades) {
		double[]cant = cantidades;
		int i = 0;
		while(i<cant.length){
			cant[i] = 0;
			i++;
		}
		return cant;
		
	}

	private String[] resetConceptos(String[] conceptos) {
		String[]con = conceptos;
		int i = 0;
		while(i<con.length){
			con[i] = "";
			i++;
		}
		return con;
		
	}
	
	private void openDialogOK() {
		new AlertDialog.Builder(this).setTitle(R.string.lbl_eliminarFijo).setItems(R.array.borradoOk, new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialoginterface,int which)
			{
				dialoginterface.cancel();
			}
		})
		.show();
	}
	
	private void openDialogNoOK() {
		new AlertDialog.Builder(this).setTitle(R.string.lbl_eliminarFijo).setItems(R.array.borradoNoOk, new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialoginterface,int which)
			{
				dialoginterface.cancel();
			}
		})
		.show();
	}
}

	
