package uoc.tfc.wimm;

import java.util.Calendar;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.ContentValues;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;

public class Gasto extends Activity implements OnClickListener{
	
	TextView campoFecha = null;
	private EditText campoCantidad = null;
	public double cantidad = 0;
	static final int DATE_DIALOG_ID = 0;
	private int ano=0;
	private int mes=0;
	private int dia=0;
	String fechaHoy=null;
	Spinner spinnerCategoria=null;
	private String concepto = null;
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.gasto);
        
        campoCantidad = (EditText) findViewById(R.id.campoCantidadGas);
        
        spinnerCategoria= (Spinner) findViewById(R.id.spinnerCategoriaGas);
        ArrayAdapter adapter = ArrayAdapter.createFromResource(this, R.array.categoriaGasto, android.R.layout.simple_spinner_item);
        
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinnerCategoria.setAdapter(adapter);
        
        campoFecha = (TextView) findViewById(R.id.campoFechaGas);
        
        View btnCalendar = findViewById(R.id.calendarGas);
        btnCalendar.setOnClickListener(this);
        
        View aceptar = findViewById(R.id.aceptarGas);
        aceptar.setOnClickListener(this);
        
        View cancelar = findViewById(R.id.cancelarGas);
        cancelar.setOnClickListener(this);
        
        inicializaFecha();
	}

	public void onClick(View v) {
		switch(v.getId()){
		
		case R.id.cancelarGas:
			Intent cancelar = new Intent (this, WimmActivity.class);
    		startActivity(cancelar);
    		finish();
			break;
		case R.id.aceptarGas:
			if(campoCantidad.getText().toString().equals(null) || campoCantidad.getText().toString().equals("")){
				cantidadNoOk();
				break;
			}
			
			cantidad = Double.parseDouble(campoCantidad.getText().toString());
			concepto = spinnerCategoria.getSelectedItem().toString();
			String fechaSeleccion = mes+""+ano;
			int fechaID = Integer.parseInt(fechaSeleccion);
			
			if(insertarTablaGasto(cantidad,concepto,fechaID)){
				//mensaje para usuario de todo ok
				campoCantidad.setText("");
				openDialogOK();
			}else{
				//mensaje para usuario no ok
				openDialogNoOk();
			}
			break;
			
		case R.id.calendarGas:
			showDialog(DATE_DIALOG_ID);
			
			break;
		}
		
	}
	
	private boolean insertarTablaGasto(double cant, String con, int fecha) {
		boolean rc = false;
		WimmBDManager wimmBd =new WimmBDManager(this, "BDwimm", null, 1);
	    SQLiteDatabase db = wimmBd.getWritableDatabase();
	    if(db != null){
//	    	db.execSQL("INSERT INTO Ingresos (cantidad, concepto, fecha) " +"VALUES (" + cant + ","+con+", '" + fecha +"')");
	    	ContentValues nuevoRegistro = new ContentValues();
	    	nuevoRegistro.put("fecha",fecha);
	    	nuevoRegistro.put("cantidad", cant);
	    	nuevoRegistro.put("concepto",con);
	    	db.insert("Gastos", null, nuevoRegistro);
	    	db.close();
	    	rc=true;
	    }
		return rc;
	}
	
	public boolean onCreateOptionsMenu (Menu menu){
    	super.onCreateOptionsMenu(menu);
    	MenuInflater inflater = getMenuInflater();
    	inflater.inflate(R.menu.menugasto, menu);
    	return true;
    }
	
	
	public boolean onMenuItemSelected(int featureId, MenuItem item){
    	super.onMenuItemSelected(featureId, item);
    	switch(item.getItemId()){
    	
    	case R.id.confGas:
    		startActivity(new Intent(this,ConfigGasto.class));
    		finish();
    		break;
    	case R.id.salirGas:
    		Historial h = new Historial();
    		h.setEsHistoric(false);
    		finish();
    		break;
    	default:
    		break;
    	}
    	return true;
    }
	
	private void inicializaFecha() {
		Calendar c = Calendar.getInstance();
        ano = c.get(Calendar.YEAR);
        mes = c.get(Calendar.MONTH) + 1;
        dia = c.get(Calendar.DAY_OF_MONTH);
        fechaHoy = dia +" / "+mes+" / "+ano;
        campoFecha.setText(fechaHoy);
	}
	
	private void cantidadNoOk() {
		new AlertDialog.Builder(this).setTitle(R.string.lbl_atencion).setItems(R.array.introducirCantidad, new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialoginterface,int which)
			{
				dialoginterface.cancel();
			}
		})
		.show();
		
	}
	
	private void openDialogOK() {
		new AlertDialog.Builder(this).setTitle(R.string.lbl_InsercionDatos).setItems(R.array.insercionOK, new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialoginterface,int which)
			{
				dialoginterface.cancel();
			}
		})
		.show();
	}
	
	private void openDialogNoOk() {
		new AlertDialog.Builder(this).setTitle(R.string.lbl_InsercionDatos).setItems(R.array.insercionNoOK, new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialoginterface,int which)
			{
				dialoginterface.cancel();
			}
		})
		.show();
		
	}
	
	protected Dialog onCreateDialog(int id) {
	    switch (id) {
	    case DATE_DIALOG_ID:
	        return new DatePickerDialog(this,mDateSetListener,ano, mes-1, dia);
	    }
	    return null;
	}
	
	 private DatePickerDialog.OnDateSetListener mDateSetListener = new DatePickerDialog.OnDateSetListener() {
	                
		 public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
	                    ano = year;
	                    mes = monthOfYear + 1;
	                    dia = dayOfMonth;
	                    fechaHoy = dia +" / "+mes+" / "+ano;
	                    campoFecha.setText(fechaHoy);
	                }
	            };
	
}
