package uoc.tfc.wimm;

import java.util.Calendar;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.TextView;
import android.os.Bundle;

public class ListarIngreso extends Activity implements OnClickListener {
	private TextView campoTitulo = null;
	private TextView cat1 = null;
	private TextView cat2 = null;
	private TextView cat3 = null;
	private TextView cat4 = null;
	private TextView cat5 = null;
	private TextView cat6 = null;
	
	private int mes = 0;
	private int ano = 0;
	private int categoria1 = 0;
	private int categoria2 = 0;
	private int categoria3 = 0;
	private int categoria4 = 0;
	private int categoria5= 0;
	private int categoria6 = 0;
	Historial h = new Historial();
	
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.listadoingresos);
        
        campoTitulo = (TextView) findViewById(R.id.tituloListIngresos);
        
        View btn_atras = findViewById(R.id.atrasListIngreso);
        btn_atras.setOnClickListener(this);
        
        cat1 = (TextView) findViewById(R.id.campIng1);
        cat2 = (TextView) findViewById(R.id.campIng2);
        cat3 = (TextView) findViewById(R.id.campIng3);
        cat4 = (TextView) findViewById(R.id.campIng4);
        cat5 = (TextView) findViewById(R.id.campIng5);
        cat6 = (TextView) findViewById(R.id.campIng6);
        
        
        if(h.getEsHistorico()){
        	mes = h.getMesHistorico();
        	ano = h.getAnoHistorico();

        }else{
        	Calendar c = Calendar.getInstance();
        	mes = c.get(Calendar.MONTH)+1;
        	ano = c.get(Calendar.YEAR);
        }
        
        inicializarMes();
        inicializarValores();
        
	}

	private void inicializarValores() {
		
		 
        String fecha = String.valueOf(mes);
        fecha = fecha+""+String.valueOf(ano);
        WimmBDManager wimmBD = new WimmBDManager(this, "BDwimm", null, 1);
        SQLiteDatabase db = wimmBD.getReadableDatabase();
        
        String[] camposIng = new String[]{"cantidad","concepto"};
        String[] argsIng = new String[]{fecha};
        Cursor cursorIngreso = db.query("Ingresos", camposIng, "fecha=?", argsIng, null, null, null);
        
        if(cursorIngreso.moveToFirst()){
        	do{
        		String cantidad = cursorIngreso.getString(0);
        		double cant = Double.valueOf(cantidad).doubleValue();
        		String concepto = cursorIngreso.getString(1);
        		if(concepto.equals(getText(R.string.array_ing_ca1)) ){
        			categoria1 += cant;
        		}else if(concepto.equals(getText(R.string.array_ing_ca2))){
        			categoria2 += cant;
        		}else if(concepto.equals(getText(R.string.array_ing_ca3))){
        			categoria3 += cant;
        		}else if(concepto.equals(getText(R.string.array_ing_ca4))){
        			categoria4 += cant;
        		}else if(concepto.equals(getText(R.string.array_ing_ca5))){
        			categoria5 += cant;
        		}else if(concepto.equals(getText(R.string.array_ing_ca6))){
        			categoria6 += cant;
        		}
        		
        	}while(cursorIngreso.moveToNext());
        }
        
        db.close();
        
        if(categoria1 != 0){
        	cat1.setText(String.valueOf(categoria1));
        }
        if(categoria2 != 0){
        	cat2.setText(String.valueOf(categoria2));
        }
        if(categoria3 != 0){
        	cat3.setText(String.valueOf(categoria3));
        }
        if(categoria4 != 0){
        	cat4.setText(String.valueOf(categoria4));
        }
        if(categoria5 != 0){
        	cat5.setText(String.valueOf(categoria5));
        }
        if(categoria6 != 0){
        	cat6.setText(String.valueOf(categoria6));
        }
        
        reseteoVariables();
        
        
        
	}

	private void reseteoVariables() {
		categoria1=0;
		categoria2=0;
		categoria3=0;
		categoria4=0;
		categoria5=0;
		categoria6=0;
	}

	public void onClick(View v) {
		switch(v.getId()){
		case R.id.atrasListIngreso:
			startActivity(new Intent(this, Consulta.class));
			finish();
			break;
		}
		
	}
	
	private void inicializarMes() {
		switch(mes){
		case 1:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos) +" "+ getText(R.string.enero));
			break;
		case 2:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos)+" "+ getText(R.string.febrero));
			break;
		case 3:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos) +" "+ getText(R.string.marzo));
			break;
		case 4:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos)+" "+ getText(R.string.abril));
			break;
		case 5:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos) +" "+ getText(R.string.mayo));
			break;
		case 6:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos)+" "+ getText(R.string.junio));
			break;
		case 7:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos)+" "+ getText(R.string.julio));
			break;
		case 8:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos)+" "+ getText(R.string.agosto));
			break;
		case 9:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos)+" "+ getText(R.string.septiembre));
			break;
		case 10:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos)+" "+ getText(R.string.octubre));
			break;
		case 11:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos)+" "+ getText(R.string.noviembre));
			break;
		case 12:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos)+" "+ getText(R.string.diciembre));
			break;
		default:
			campoTitulo.setText(getText(R.string.titulo_listadoIngresos));
			break;
			
		}
	}
	
	public boolean onCreateOptionsMenu (Menu menu){
    	super.onCreateOptionsMenu(menu);
    	MenuInflater inflater = getMenuInflater();
    	inflater.inflate(R.menu.menuconsulta, menu);
    	return true;
    }
	
	
	public boolean onMenuItemSelected(int featureId, MenuItem item){
    	super.onMenuItemSelected(featureId, item);
    	switch(item.getItemId()){
    	case R.id.salirCons:
    		h.setEsHistoric(false);
    		finish();
    		break;
    	default:
    		break;
    	}
    	return true;
    }
	
}
