package uoc.tfc.wimm;

import java.util.Calendar;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.ContentValues;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;

public class WimmActivity extends Activity implements OnClickListener {
    
    Calendar c = Calendar.getInstance();
	int diaHoy = c.get(Calendar.DAY_OF_MONTH);
	static int controlDiaEvaluado = 0;
	
	ConfigIngreso cf = new ConfigIngreso();
	ConfigGasto cg = new ConfigGasto();
	
	private static int[] diasMarcadosIngreso = new int[10];
    public static int posicionTablaDiasMarcadosIngreso = 0;
    
	private static int[] diasMarcadosGasto = new int[10];
    public static int posicionTablaDiasMarcadosGasto = 0;
    
    
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        View ingresarButton = findViewById(R.id.btn_ingreso);
        ingresarButton.setOnClickListener(this);
        
        View gastoButton = findViewById(R.id.btn_gasto);
        gastoButton.setOnClickListener(this);
        
        View consultaButton = findViewById(R.id.btn_consulta);
        consultaButton.setOnClickListener(this);
        
        View histButton = findViewById(R.id.btn_historial);
        histButton.setOnClickListener(this);
        
        View opButton = findViewById(R.id.btn_opciones);
        opButton.setOnClickListener(this);
        
        if(diaHoy != controlDiaEvaluado && cf.getExistenIngresosFijos()){
        	evaluarIngresosFijos();
        }
        
        if(diaHoy != controlDiaEvaluado && cg.getExistenGastosFijos()){
        	 evaluarGastosFijos();
        }
       
        
    }
    

	private void evaluarIngresosFijos() {
		
		if(cf.getExistenIngresosFijos()){
    		int[] dias = cf.getDiasIngresos();
    		double[] cantidades = cf.getcantidadesIngresoFijo();
    		String[] conceptos = cf.getconceptosIngresoFijo();
    		int[] fechasID = cf.getfechaIDIngresoFijo();
    		
    		int i = 0;
    		while( i < dias.length ){
    			
    			if(diaCorrectoIngreso(dias[i]) && diaHoy >= dias[i] && dias[i]!=0){
    				diasMarcadosIngreso[posicionTablaDiasMarcadosIngreso] = dias[i];
    				posicionTablaDiasMarcadosIngreso++;
    				
    				double cantidad = cantidades[i];
    				String concepto = conceptos[i];
    				int fechaID = fechasID[i];
    				if(insertarTablaIngreso(cantidad,concepto,fechaID)){
    					openDialogOK();
    				}else{
    					openDialogNoOk();
    				}
    				
    			}
    			i++;
    			
    		}
    		if(diaHoy == c.getActualMaximum(Calendar.DAY_OF_MONTH)){
    			int j = 0;
    			while(j< diasMarcadosIngreso.length){
    				diasMarcadosIngreso[j] = 0;
    				j++;
    			}
    		}
    		
    	}
		controlDiaEvaluado = diaHoy;
	}
	
	private boolean insertarTablaIngreso(double cant, String con,int fecha) {
		boolean rc = false;
		WimmBDManager wimmBd =new WimmBDManager(this, "BDwimm", null, 1);
	    SQLiteDatabase db = wimmBd.getWritableDatabase();
	    if(db != null){
//	    	db.execSQL("INSERT INTO Ingresos (cantidad, concepto, fecha) " +"VALUES (" + cant + ","+con+", '" + fecha +"')");
	    	ContentValues nuevoRegistro = new ContentValues();
	    	nuevoRegistro.put("fecha",fecha);
	    	nuevoRegistro.put("cantidad", cant);
	    	nuevoRegistro.put("concepto",con);
	    	db.insert("Ingresos", null, nuevoRegistro);
	    	db.close();
	    	rc=true;
	    }
		return rc;
		
	}


	private boolean diaCorrectoIngreso(int dia) {
		int k =0;
		boolean diaOk = true;
		while(k < diasMarcadosIngreso.length){
			if(diasMarcadosIngreso[k] == dia){
				diaOk = false;
			}
			k++;
		}
		return diaOk;
	}
	
	private boolean diaCorrectoGastos(int dia) {
		int k =0;
		boolean diaOk = true;
		while(k < diasMarcadosGasto.length){
			if(diasMarcadosGasto[k] == dia){
				diaOk = false;
			}
			k++;
		}
		return diaOk;
	}


	private void evaluarGastosFijos() {
		if(cg.getExistenGastosFijos()){
    		int[] dias = cg.getDiasGastos();
    		double[] cantidades = cg.getcantidadesGastosFijo();
    		String[] conceptos = cg.getconceptosGastosFijo();
    		int[] fechasID = cg.getfechaIDGastosFijo();
    		
    		int i = 0;
    		while( i < dias.length ){
    			
    			if(diaCorrectoGastos(dias[i]) && diaHoy >= dias[i] && dias[i]!=0){
    				diasMarcadosGasto[posicionTablaDiasMarcadosGasto] = dias[i];
    				posicionTablaDiasMarcadosGasto++;
    				
    				double cantidad = cantidades[i];
    				String concepto = conceptos[i];
    				int fechaID = fechasID[i];
    				if(insertarTablaGasto(cantidad,concepto,fechaID)){
    					openDialogOK();
    				}else{
    					openDialogNoOk();
    				}
    				
    			}
    			i++;
    			
    		}
    		if(diaHoy == c.getActualMaximum(Calendar.DAY_OF_MONTH)){
    			int j = 0;
    			while(j< diasMarcadosGasto.length){
    				diasMarcadosGasto[j] = 0;
    				j++;
    			}
    		}
    		
    	}
		controlDiaEvaluado = diaHoy;
		
	}
	
	private boolean insertarTablaGasto(double cant, String con, int fecha) {
		boolean rc = false;
		WimmBDManager wimmBd =new WimmBDManager(this, "BDwimm", null, 1);
	    SQLiteDatabase db = wimmBd.getWritableDatabase();
	    if(db != null){
//	    	db.execSQL("INSERT INTO Ingresos (cantidad, concepto, fecha) " +"VALUES (" + cant + ","+con+", '" + fecha +"')");
	    	ContentValues nuevoRegistro = new ContentValues();
	    	nuevoRegistro.put("fecha",fecha);
	    	nuevoRegistro.put("cantidad", cant);
	    	nuevoRegistro.put("concepto",con);
	    	db.insert("Gastos", null, nuevoRegistro);
	    	db.close();
	    	rc=true;
	    }
		return rc;
	}

	public void onClick(View v) {
    	switch(v.getId()){
    	
    	case R.id.btn_ingreso:
    		Intent i_ing = new Intent (this, Ingresar.class);
    		startActivity(i_ing);
    		finish();
    		break;
    	case R.id.btn_gasto:	
    		Intent i_gast = new Intent (this, Gasto.class);
    		startActivity(i_gast);
    		finish();
    		break;
    	case R.id.btn_consulta:
    		Intent i_cons = new Intent (this, Consulta.class);
    		startActivity(i_cons);
    		finish();
    		break;
    	case R.id.btn_historial:
    		Intent i_hist = new Intent (this, Historial.class);
    		startActivity(i_hist);
    		finish();
    		break;
    	case R.id.btn_opciones:	
    		Intent i_op = new Intent (this, Opciones.class);
    		startActivity(i_op);
    		finish();
    		break;
    	}
    }
    
    public boolean onCreateOptionsMenu (Menu menu){
    	super.onCreateOptionsMenu(menu);
    	MenuInflater inflater = getMenuInflater();
    	inflater.inflate(R.menu.menu, menu);
    	return true;
    }
    
    public boolean onMenuItemSelected(int featureId, MenuItem item){
    	super.onMenuItemSelected(featureId, item);
    	switch(item.getItemId()){
    	
    	case R.id.sobre:
    		startActivity(new Intent(this,Sobre.class));
    		break;
    	case R.id.salir:
    		Historial h = new Historial();
    		h.setEsHistoric(false);
    		finish();
    		break;
    	default:
    		break;
    	}
    	return true;
    }
    
    private void openDialogNoOk() {
		new AlertDialog.Builder(this).setTitle(R.string.txt_FijNoOk).setItems(R.array.insercionNoOK, new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialoginterface,int which)
			{
				dialoginterface.cancel();
			}
		})
		.show();
		
	}


	private void openDialogOK() {
		new AlertDialog.Builder(this).setTitle(R.string.txt_FijOk).setItems(R.array.insercionOK, new DialogInterface.OnClickListener(){ 
			public void onClick(DialogInterface dialoginterface,int which)
			{
				dialoginterface.cancel();
			}
		})
		.show();
	}
    
}