package uoc.tfc.wimm;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteDatabase.CursorFactory;
import android.database.sqlite.SQLiteOpenHelper;

public class WimmBDManager extends SQLiteOpenHelper{
	
	String sqlCreateIngresos = "CREATE TABLE Ingresos (fecha INTEGER, cantidad DOUBLE, concepto TEXT)";
	String sqlCreateGastos = "CREATE TABLE Gastos (fecha INTEGER, cantidad DOUBLE, concepto TEXT)";
	
	
	public WimmBDManager(Context contexto, String nombre,CursorFactory factory, int version) {
		super(contexto, nombre, factory, version);
	}

	
	public void onCreate(SQLiteDatabase db) {
		
		 db.execSQL(sqlCreateIngresos);
		 db.execSQL(sqlCreateGastos);
	}

	
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		/*
		 * Si en algun momento hubiese una version donde se tuviese que actualizar los campos
		 * de la tabla se haria en este metodo, de momento haremos que borre y cree de nuevo la
		 * tabla
		 */
		
		db.execSQL("DROP TABLE IF EXISTS Ingresos");
        //Se crea la nueva versin de la tabla
        db.execSQL(sqlCreateIngresos);
        
        db.execSQL("DROP TABLE IF EXISTS Ingresos");
        db.execSQL(sqlCreateGastos);
	}

}
